//
//  gamevilCircle.h
//  gamevilCircle
//
//  Created by KyungJin Kwon on 12. 8. 10..
//  Copyright (c) 2012년 Gamevil. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>
#import <StoreKit/StoreKit.h>
#import "gamevilCircleDef.h"


typedef enum _tagGVDirection {
	GVDirectionUp,
	GVDirectionDown,
} GVDirection;

typedef enum _tagHostType {
	AWC_HOST,
	IDC_HOST,
} GVCHostType;

#define GamevilLiveWillShow		@"GamevilLiveWillShow"
#define GamevilLiveWillHide		@"GamevilLiveWillHide"

#define kLocalStringKorea		@"kr"
#define kLocalStringEnglish		@"en"

#define kPureIPhone				0
#define kJailBorken				1
#define kIAPCracker				2

#define kAppTypePlus			18
#define kAppTypeFree			19
#define kAppTypePadPlus			29
#define kAppTypePadFree			30

#define kMarketIOS           @"4"


#define NEWS_TYPE_NORMAL            2
#define NEWS_TYPE_FULL              1

#define NEWS_POS_TOPDOWN            0
#define NEWS_POS_BOTTOMUP           1
#define NEWS_POS_FULL               -1

#define GAMEVIL_USA                 0
#define GAMEVIL_KOR                 1

#define GAMEVIL_DEFAULT             0
#define GAMEVIL_LIVELITE            1
#define GAMEVIL_LIVEFULL            2
#define GAMEVIL_KAKAO               3

static int OPT_CIH_CHECK 			= 0x00000010;
static int OPT_CIH_NETCHECK_PASS		= 0x00000200;


@protocol VerifyReceiptDelegate <NSObject>
@required
- (void)receiptConnectFailed:(SKPaymentTransaction *)transaction;
- (void)receiptValid:(SKPaymentTransaction *)transaction;
- (void)receiptInvalid:(SKPaymentTransaction *)transaction withErrorCode:(int)error;
@optional
- (void)receiptConnected:(SKPaymentTransaction *)transaction;
- (void)receiptTimeout:(SKPaymentTransaction *)transaction;
@end

@protocol GVCryptDelegate <NSObject>
@required
- (NSData *)cryptKey:(const char *)param withParamSize:(size_t)paramSize;
@end

@protocol GvCIDelegate <NSObject>

@required
-(void) CIPlayFinish;
@end

@interface gamevilCircle : NSObject
{
}

#pragma mark -
#pragma mark Common function
+(void)SetKeyChainGroup:(NSString*)_KeyGroup;
+(NSString *)GetKeyChainGroup;

+(void)setDisableOptions:(int)value;
+(BOOL)isDisabled:(int)disableflag;

+(void)SetLinePlatform:(BOOL)_LineFlag;
+(BOOL)GetLinePlatform;
+(void)SetTestHost:(BOOL)_IsTestHost;
+(BOOL)GetTestHost;
+(void)SetUnity3dPlatform:(BOOL)_unityFlag;
+(BOOL)GetUnit3dFlag;

+(NSString *)getVersion;
+(NSString*)getPhoneModel;
+(NSString*)getOsVersion;
+(BOOL)IsIPad;

+(NSString *) setConfig:(NSData*)_messagedata;
+(NSString *) getVISIME:(NSString*)_rowData;
+ (NSData*) strToHex : (NSString *)hexString;

+(NSString *) calcUrl:(NSString*)_string;
+(BOOL)isAsiaClient;

+(NSString * ) stringToBase64:(NSString *) oriString;
+(BOOL)IsIPhone5Widescreen;

+(NSString *)GetNetworkMcc;

#pragma mark -
#pragma mark CI function

+(void)GamevilLogoInitUnity3d:(UIViewController*)rootViewController withDelegate:(id<GvCIDelegate>)delegate ;
+(void)GamevilLogoShowUnity3d;

+(void)GamevilLogoShow:(UIViewController*)rootViewController withDelegate:(id<GvCIDelegate>)delegate ;
+(void)GamevilLogoHide;


#pragma mark -
#pragma mark anti-Hacking function

+(void)SetCheckKey:(NSString*)_key;
+(void)CheckTime;
+(void)ResumeCheck;
+(BOOL)GetCheckTime;

#pragma mark -
#pragma mark ProfileData function
+(void)setMemberShipCode:(int)membershipcode;
+(int)getMemberShipCode;

+(void)setCorporationCode:(int)corporationcode;
+(int)getCorporationCode;

+(void)ResetProfileTerms;
+(int)SendProfileDataWithHostType:(GVCHostType)_hostType withGID:(int)_GID  withSaleCode:(int)_SaleCode withViewController:(UIViewController*)_viewcontroller withTerms:(BOOL)_TermsFlag;

#pragma mark -
#pragma mark CPIConnect function
+(void)CPIConnectwithCPIID:(NSString*)_CPIID withGameID:(NSString*)_gameID withCPIsalecode:(NSString*)_salecode withCPIMarketCode:(NSString*)_marketcode withCPIPackagename:(NSString*)_packagename;
+(void)CPIResume;
+(void)CPISuspend;
#pragma mark -
#pragma mark UUID function
+(NSString*)getUUID;
+(void)setBakcupUUID;
+(NSString*)getBackupUUID;


#pragma mark -
#pragma mark Receipt function
+(int)checkDevice;
+(int)verifyReceiptWithTransaction:(SKPaymentTransaction *)transaction withGameID:(int)_netid withsalecd:(int)_salecd withItemSeq:(int)item WithDelegate:(id<VerifyReceiptDelegate>)delegate;



#pragma mark -
#pragma mark pushNotification function
+ (void)registerNotification;
+ (void)sendDeviceToken:(NSData *)token withGameID:(int)_netid withSalecd:(int)_salecd;
+ (void)didFailToRegisterForRemoteNotificationWithError:(NSError*) error;
+ (void)application:(UIApplication*)application receiveRemoteNotification:(NSDictionary*)userInfo withGameTitle:(NSString*)_gametitle;
+ (void)destroyNotification;
+ (void)resetNotification;

+ (void)registerLocalPush:(NSString *)message inTime:(NSDate *)date withPushId:(NSString *)pushId;
+ (void)registerLocalPush:(NSString *)message after:(int)seconds withPushId:(NSString *)pushId;
+ (void)deleteLocalPush:(NSString *)pushId;
+ (void)deleteAllLocalPush;

+ (NSData *) getBackupToken;

#pragma mark -
#pragma mark openReview function
+ (void)openReview:(NSString *)appId;

#pragma mark -
#pragma mark encrypt function
+ (size_t)encrypt:(const char *)data withSize:(size_t)dataSize toBuf:(char *)buf withSize:(size_t)bufSize withCryptDelegate:(id<GVCryptDelegate>)delegate withParam:(const char *)param withParamSize:(size_t)paramSize;
+ (size_t)decrypt:(const char *)data withSize:(size_t)dataSize toBuf:(char *)buf withSize:(size_t)bufSize withCryptDelegate:(id<GVCryptDelegate>)delegate withParam:(const char *)param withParamSize:(size_t)paramSize;

#pragma mark -
#pragma mark newsbanner function

+(void)CreateBannerWithSuperView:(UIView*)view withGameID:(NSString *)_gameID withVersion:(NSString*)_appversion;
+(void)AddBannerWithAddressId:(NSString*)addressId withType:(int)newstype withDirection:(int)_direction;
+(void)InitBannerConnectBannerServer;
+(void)BannerCheckLaunchingOption:(NSDictionary*)launchOption;
+(void)BannerMakeImpression;
+(void)loadBannerWithId:(NSString*)_id;
+(void)showBannerWithId:(NSString*)_id;
+(void)freeBannerWithId:(NSString*)_id;
+(BOOL)existBannerWithID:(NSString*)_id;

#pragma mark -
#pragma mark DebugTools function

+(void)DBT_Init;
+(void)DBT_Show:(UIView*)superView;
+(void)DBT_Hide;
+(void)DBT_MemoryWarning;
+(void)DBT_SetLog:(BOOL)flag withLogTime:(float)time;
@end
